/*
  Projekt: Jak na projekty v jazyce C
  Autor: David Martinek, martinek (zavin) fit.vutbr.cz
  Datum: 11.02.2009
  Kdovn dokumentu: ISO8859-2
  Popis: Tento program slou pro demonstraci zkladnch stavebnch prvk
         jazyka C.
*/

// Jak st tento zdrojov soubor
// 1. Zante sekc pro vkldn rozhran knihoven.
// 2. Podvejte se na funkci main, kter se nachz na konci souboru.
// 3. Ve funkci main se v uritm poad volaj jednotliv podprogramy.
//    V tom poad, v jakm se volaj ve funkci main, si prohldnte jejich
//    definice v prostedn sti zdrojovho souboru. Ped kadou funkc se
//    nachz koment, kter vysvtluje, co se v tto funkci dje.
// 4. Pelote tento zdrojov soubor pomoc pekladae jazyka C. Na webovch
//    strnkch Jak na projekty v jazyce C najdete postup, jak peklada
//    zavolat.
//    Tak mete pout pkaz make. Makefile je pibalen. Pokud nerozumte,
//    co to znamen, pette si o programu make na webovch strnkch.


////////// Sekce pro vkldn rozhran knihoven ///////////////////////////////

// Zde se vkld rozhran knihoven, kter bude program pouvat. V tomto
// programu se budou pouvat podprogramy z nkolika st systmov knihovny.
// V tomto konkrtnm ppad bude poteba rozhran stdio.h, stdlib.h, math.h,
// limits.h a float.h.
// Informaci o tom, jak rozhran je poteba pout, se dozvte v npovd
// k systmovm funkcm (napklad v manulovch strnkch).
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <float.h>

///////// Definice podprogram ////////////////////////////////////////////////

//== zatek == jednoduch tisk na obrazovku ==
/**
 * Funkce bez parametr a bez nvratov hodnoty (klov slovo void).
 * Pomoc systmov funkce printf vytiskne npis na standardn vstup programu.
 * Vimnte si, e oddkovn se provd vloenm \n do textu.
 * Vimnte si, e vce textovch etzc za sebou, kter jsou oddleny jenom
 * mezerami, tvo jeden textov etzec.
 */
void hello(void)
{
  printf("Ahoj.\n"
         "J jsem program pro demonstraci zkladnch konstrukc jazyka C.\n");
}

/**
 * Funkce bez nvratov hodnoty, ale s jednm parametrem. Parametr signature
 * je textov etzec (typ char*). Pomoc tohoto parametru meme mnit
 * st textu, kter se bude tisknout.
 *
 * Vimnte si znaky %s v titnm etzci. Na mst tto znaky se vytiskne
 * obsah promnn, kter se nachz za etzcem. V tomto ppad jde
 * o promnnou signature.
 */
void signedHello(char *signature)
{
  printf("Ahoj.\nJ jsem program pro demonstraci konstrukc jazyka C.\n"
         "Mm autorem je %s.\n", signature);
}
//== konec == jednoduch tisk na obrazovku ==





//== zatek == lokln promnn
/**
 * Funkce bez parametr a bez nvratov hodnoty. Demonstruje vytven
 * celoselnch promnnch.
 *
 * Vimnte si, e deklarace promnnch se me vyskytovat i uprosted programu
 */
void variables(void)
{
  int a;     // deklarace (a zrove definicie) promnn bez inicializace,
             // promnn a m te neznmou hodnotu
  int b = 7; // definice promnn b s inicializaci, b m hodnotu 7

  a = 11;         // nastaven hodnoty promnn a na hodnotu 11
  int c = a + b;  // definice a inicializace promnn c, c m te hodnotu 18

  // tisk selnch hodnot promnnch a, b, c
  printf("souet %d a %d je %d\n", a, b, c);

  // vimnte si, e msto promnn, se zde me vyskytovat i vraz, pokud je
  // vsledkem sprvn datov typ
  printf("souin %d a %d je %d\n", a, b, a * b);
}

/**
 * Funkce pro demonstraci, jak tisknout hodnoty jednoduchch typ na
 * standardn vstup.
 *
 * Vimnte si maximlnch hodnot jednotlivch selnch typ.
 * Vimnte si, jak formtovac znaky pouv funkce printf pro tisk
 * hodnot jednotlivch datovch typ.
 * Deklarace konstant obsahujcch maximln hodnoty jednotlivch typ se
 * se nachz v hlavikovch souborech limits.h (CHAR_MAX a ULLONG_MAX)
 * a float.h (FLT_MAX, DBL_MAX).
 */
void printTypes(void)
{
  char znak = 'A';               // char se d pout jako znak...
  char malecislo = CHAR_MAX;     // ... ale tak jako mal cel slo
  char * text = "Toto je textov etzec.";

  short strednicislo = SHRT_MAX; // short -- stedn velk cel sla
  int cislo = INT_MAX;           // int -- bn pouvan cel sla
  long vetsicislo = LONG_MAX;    // long -- del cel sla
  long long obrovskecislo = LLONG_MAX; // long long velmi velk cel sla

  // Pouitm pedpony unsigned vyrobme bezznamnkov typ -- pouze kladn
  // cel sla. Typ unsigned nelze pout s jinmi ne celoselnmi typy.
  unsigned char kladnemale = UCHAR_MAX;
  unsigned short kladnestredni = USHRT_MAX;
  unsigned int kladnecislo = UINT_MAX;
  unsigned long kladnevetsi = ULONG_MAX;
  unsigned long long kladneobrovske = ULLONG_MAX;

  float descislo = FLT_MAX;    // desetinn sla s jednoduchou pesnost
  double presnejsi = DBL_MAX;  // desetinn sla s dvojitou pesnost

  printf("Pehled jednoduchch datovch typ.\n");
  printf("char jako slo -- maximum:    %hhd\n", malecislo);
  printf("unsigned char -- maximum:      %hhu\n", kladnemale);
  printf("short -- maximum:              %hd\n", strednicislo);
  printf("unsigned short -- maximum:     %hu\n", kladnestredni);
  printf("int -- maximum:                %d\n", cislo);
  printf("unsigned int -- maximum:       %u\n", kladnecislo);
  printf("long -- maximum:               %ld\n", vetsicislo);
  printf("unsigned long -- maximum:      %lu\n", kladnevetsi);
  printf("long long -- maximum:          %lld\n", obrovskecislo);
  printf("unsigned long long -- maximum: %llu\n", kladneobrovske);
  printf("float -- maximum:              %g\n", descislo);
  printf("double -- maximum:             %g\n", presnejsi);
  printf("char jako znak: %c\n", znak);
  printf("textov etzec: %s\n", text);
}

//== konec == lokln promnn





//== zatek == funkce bez nvratov hodnoty s parametry pedvanmi hodnotou
/**
 * Funkce bez nvratov hodnoty, ale s parametry pedvanmi hodnotou.
 * Hodnota parametr a a b se nyn specifikuje a pi zavoln funkce, take
 * vsledek zvis na tom, jak programtor tuto funkci pouije.
 */
void parameters1(int a, int b)
{
  int c = a + b; // hodnota lokln promnn c je rovna soutu hodnot a a b

  // tisk selnch hodnot promnnch a, b, c
  printf("souet %d a %d je %d\n", a, b, c);

  // tisk souinu hodnot a a b
  printf("souin %d a %d je %d\n", a, b, a * b);
}
//== konec == funkce bez nvratov hodnoty s parametry pedvanmi hodnotou





//== zatek == funkce s nvratovou hodnotou
/**
 * Vypote obsah trojhelnka pomoc Heronova vzorce.
 * Parametry a, b, c udvaj dlky jednotlivch stran.
 * Funkce vrac obsah trojhelnka jako svoji nvratovou hodnotu.
 * Funkce pouv funkci sqrt pro vpoet odmocniny. Tato funkce se nachz
 * v matematick knihovn, proto bylo poteba pout rozhran math.h.
 *
 * Pozor! Funkce v tto podob funguje chybn pro takov zadn, ze kterch
 * nelze sestrojit trojhelnk. Zkuste se zamyslet, jak ppady to jsou.
 */
double getArea(double a, double b, double c)
{
  double s = (a + b + c)/2.0;       // pomocn lokln promnn
  return sqrt(s*(s-a)*(s-b)*(s-c)); // pkaz return vrac vslednou hodnotu
                                    // pro volajc funkci
}

/**
 * Funkce se temi parametry bez nvratov hodnoty. Vol funkci getArea.
 * Demonstruje voln funkce s parametry a zskvn jej nvratov hodnoty.
 */
void triangle(double a, double b, double c)
{
  // pomocn lokln promnn
  double obvod = a + b + c;

  // Zavol funkci getArea definovanou ve, kter z parametr a, b, c
  // vypote obsah trojhelnka a vrt jej jako svou nvratovou hodnotu.
  // Tato hodnota se zde nsledn ulo do promnn obsah.
  double obsah = getArea(a, b, c);

  printf("Mme dn trojhelnk o stranch a=%f, b=%f, c=%f.\n"
         "Obvod trojhelnka je %f.\n"
         "Obsah trojhelnka je %f.\n",
         a, b, c, obvod, obsah);
}
//== konec == funkce s nvratovou hodnotou




//== zatek == funkce s parametry pedvanmi odkazem
/**
 * Funkce bez nvratov hodnoty, ale se dvma parametry pedvanmi odkazem.
 * Funkce swap vymn obsahy zadanch promnnch.
 * Parametry a a b se zde pedvaj odkazem, tedy pomoc ukazatele. Typ int *
 * znamen "ukazatel na int". Uvnit funkce musme s hodnotami pracovat pomoc
 * dereferennho opertoru *.
 */
void swap(int *a, int *b)
{
  int tmp = *a;  // uchovn hodnoty promnn *a
  *a = *b;       // do *a ulo hodnotu *b
  *b = tmp;      // do *b ulo hodnotu promnn tmp

  // Pozor!
  // a -- promnn typu ukazatel na int
  // *a -- pohled na msto v pamti, kam ukazatel a odkazuje, tedy promnn
  //       typu int
}

/**
 * Demonstrace voln funkc s parametry pedvanmi odkazem.
 * Vol funkci swap, kter m dva parametry pedvan odkazem.
 */
void parameters2(void)
{
  int x = -115;
  int y = 687;

  printf("Inicializace: x = %d, y = %d\n", x, y);

  // Funkce swap oekv, e za parametry dosadme ukazatele na int.
  // Potebujeme tedy zjistit, na jakch adresch pamti le promnn x a y.
  // Vyuijeme k tomu referenn opertor &. Vraz &x vrac adresu promnn x,
  // ili ukazatel na promnnou x.
  swap(&x, &y);

  printf("Po zavoln swap(&x, &y): x = %d, y = %d\n", x, y);

  // Vimnte si, e do parametr pedvanch odkazem nelze dosadit konstantn
  // vraz, protoe takov vraz 1) nelze modifikovat 2) nejsme schopni urit
  // jeho adresu v pamti.
  // Nsledujc pklady jsou nesmysln.
  // swap(12, 3+x);      -- tohle nejde
  // swap(&12, &(3+x));  -- ani tohle nejde
}
//== konec == funkce s parametry pedvanmi odkazem




//== zatek == kombinace vech t zpsob komunikace funkce s okolm
/**
 * Bezpen dlen. Funkce vypote podl a zbytek po dlen dvou sel.
 * Pokud je ve v podku, je jej nvratovou hodnotou logick hodnota true
 * (jednika) a parametr divident bude obsahovat celoseln podl a parametr
 * remainder bude obsahovat zbytek po dlen. Pokud by mlo dojt k dlen
 * nulou, kter pro cel sla nen definovno, funkce vrt false (nula).
 * V tomto ppad zstanou hodnoty parametr divident a remainder nedoteny.
 */
int safeDivision(int *divident, int divisor, int *remainder)
{
  if (divisor == 0)
    return 0; // false

  *remainder = *divident % divisor;  // zbytek po celoselnm dlen
  *divident = *divident / divisor;   // celoseln dlen
  return 1;  // true
}

/**
 * Demonstrace voln funkce safeDivision, kde se kombinuje nvratov hodnota,
 * parametry pedvan hodnotou i odkazem.
 */
void parameters3(int x, int y)
{
  int rest;   // Pozor! Neinicializovan hodnota je patn zvyk!
              // Vtinou zde asi bude hodnota 0, ale ned se na to spolhat!

  printf("Ped vpotem: x = %d, y = %d, rest = %d\n", x, y, rest);

  // Voln funkce safeDivision a okamit pouit jej nvratov hodnoty
  // v podmnce pkazu if. Promnn x a rest se pedvaj odkazem, protoe
  // budou ve funkci modifikovny. Promnn y se pedv hodnotou a jej
  // hodnota se neme zmnit.
  if (safeDivision(&x, y, &rest))
  {
    printf("Po dlen: x = %d, y = %d, rest = %d\n", x, y, rest);
  }
  else
  {
    printf("Dlen nulou! Nic se nespotalo: x = %d, y = %d, rest = %d\n", x, y, rest);
  }
}
//== konec == kombinace vech t zpsob komunikace funkce s okolm



///////// Funkce main /////////////////////////////////////////////////////////

/**
 * Hlavn funkce programu. Zde se nachz startovac bod programu. Funkce
 * main se spust jako prvn pi sputn peloenho programu. Z tto funkce
 * se volaj vechny ostatn podprogramy.
 *
 * V tomto ppad jde o funkci bez parametr (to k klov slovo void),
 * kter vrac hodnotu typu int. Podle tto hodnoty operan systm, kter
 * tuto funkci zavolal, pozn, zda program skonil bez problm nebo jestli
 * nedolo k njak chyb.
 */
int main(void)
{
  printf("=== funkce hello ===\n");
  hello();  // zvorky zde nesmj chybt!

  printf("\n=== funkce signedHello ===\n");
  signedHello("David Martinek"); //za parametr dosazen etzec "David Martinek"


  printf("\n=== funkce variables ===\n");
  variables(); // zvorky zde nesmj chybt!

  printf("\n=== funkce printTypes ===\n");
  printTypes();// zvorky zde nesmj chybt!


  printf("\n=== funkce parameters ===\n");
  // parametr a obdr kopii hodnoty 17
  // parametr b obdr kopii hodnoty 24
  parameters1(17, 24);


  printf("\n=== funkce triangle - obsah trojhelnka ===\n");
  // strany trojhelnka maj dlku 43.2, 92.4 a 62.3
  triangle(43.2, 92.4, 62.3);

  printf("\n=== funkce triangle - co kdy ze zadanch hodnot nelze vytvoit trojhelnk? ===\n");
  // strany trojhelnka maj dlku 2.5, 3.1 a 12.0 -- takov trojhelnk
  // nelze zkonstruovat
  triangle(2.5, 3.1, 12.0);
  // Poznmka: NaN znamen Not a Number - speciln hodnota typu double,
  //           kter se pouv pro situace, kdy vsledek operace nen
  //           definovn.


  printf("\n=== funkce parameters2 - pedvn parametr odkazem ===\n");
  parameters2();


  printf("\n=== funkce parameters3 - parametry odkazem i hodnotou ===\n");
  parameters3(46, 21);

  printf("\n=== funkce parameters3 - dlen nulou ===\n");
  parameters3(46, 0);

  return EXIT_SUCCESS;  // program kon bez chyby
}
